/*
	Copyright (C) 2008-2013 Mark Tyler

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program in the file COPYING.
*/

#include "be.h"



static const char	* arg_filename	= NULL;



static int file_func (
	char		* filename
	)
{
	arg_filename = filename;

	return 0;			// Keep parsing
}

static int error_func (
	int		error,
	int		arg,
	int		argc,
	char		* argv[]
	)
{
	fprintf ( stderr, "error_func: Argument ERROR! - num=%i arg=%i/%i",
		error, arg, argc );

	if ( arg < argc )
	{
		fprintf ( stderr, " '%s'", argv[arg] );
	}

	fprintf ( stderr, "\n" );

	return 0;			// Keep parsing
}

const char * be_cline (
	int		argc,
	char		** argv
	)
{
	int		show_version = 0;
	char		* prefs_file = NULL;
	mtArg		arg_list[] = {
		{ "-help",	MTKIT_ARG_SWITCH,	&show_version, 2 },
		{ "-version",	MTKIT_ARG_SWITCH,	&show_version, 1 },
		{ "prefs",	MTKIT_ARG_STRING,	&prefs_file },
		{ NULL }
		};


	mtkit_arg_parse ( argc, argv, arg_list, file_func, error_func );

	switch ( show_version )
	{
	case 1:
		printf ( "%s\n\n", VERSION );
		exit ( 0 );

	case 2:
		printf (
		"%s\n\n"
		"Usage: %s [OPTIONS] [FILENAME]\n"
		"\n"
		"Options:\n"
		"  --help               Output this help\n"
		"  --version            Output version information\n"
		"\n"
		"  -prefs STRING        Use this file for program preferences\n"
		"\n"
		, VERSION, BIN_NAME );

		exit ( 0 );
	}

	return prefs_file;
}

const char * be_cline_filename ()
{
	return arg_filename;
}
