/*
	Copyright (C) 2008-2013 Mark Tyler

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program in the file COPYING.
*/

#include "be.h"



static mtPrefs		* prefs_mem;
static char		prefs_filename [ 2048 ];



void prefs_init (
	void		* ptr,
	const char	* filename
	)
{
	mtPrefItem	prefs_table[] = {

{ CED_INIFILE_LAST_DIR,	MTKIT_PREF_TYPE_DIR },

{ CED_INIFILE_MAIN_WINDOW"_state", MTKIT_PREF_TYPE_INT, "0" },
{ CED_INIFILE_MAIN_WINDOW"_x", MTKIT_PREF_TYPE_INT, "50" },
{ CED_INIFILE_MAIN_WINDOW"_y", MTKIT_PREF_TYPE_INT, "50" },
{ CED_INIFILE_MAIN_WINDOW"_w", MTKIT_PREF_TYPE_INT, "400" },
{ CED_INIFILE_MAIN_WINDOW"_h", MTKIT_PREF_TYPE_INT, "400" },

{ CED_INIFILE_SHARED_WINDOW"_x", MTKIT_PREF_TYPE_INT, "50" },
{ CED_INIFILE_SHARED_WINDOW"_y", MTKIT_PREF_TYPE_INT, "50" },
{ CED_INIFILE_SHARED_WINDOW"_w", MTKIT_PREF_TYPE_INT, "400" },
{ CED_INIFILE_SHARED_WINDOW"_h", MTKIT_PREF_TYPE_INT, "400" },

{ CED_INIFILE_HELP_FILE, MTKIT_PREF_TYPE_FILE, "/usr/share/doc/mtcelledit/en_GB/chap_00.html" },
{ CED_INIFILE_HELP_BROWSER, MTKIT_PREF_TYPE_STR, "" },

{ CED_INIFILE_MAIN_FILE"1", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"2", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"3", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"4", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"5", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"6", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"7", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"8", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"9", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"10",MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"11", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"12", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"13", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"14", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"15", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"16", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"17", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"18", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"19", MTKIT_PREF_TYPE_FILE },
{ CED_INIFILE_MAIN_FILE"20",MTKIT_PREF_TYPE_FILE },

{ CED_INIFILE_FONT_TYPE, MTKIT_PREF_TYPE_OPTION, "1", NULL, pref_change_font, 0, "8x8	8x16	Custom", ptr },
{ CED_INIFILE_FONT_FILENAME, MTKIT_PREF_TYPE_FILE, NULL, NULL, pref_change_font, 0, NULL, ptr },
{ CED_INIFILE_FONT_SIZE,	MTKIT_PREF_TYPE_INT, "16", NULL, pref_change_font, 0, "0	128", ptr },

{ CED_INIFILE_ROW_PAD,	MTKIT_PREF_TYPE_INT, "0", NULL, pref_change_row_pad, 0, "0	4", ptr },

{ CED_INIFILE_RECENT_FILENAME_LEN,	MTKIT_PREF_TYPE_INT, "80", NULL, pref_change_recent_filename_len, 0, "50	500", ptr },

{ CED_INIFILE_2DYEAR_START,	MTKIT_PREF_TYPE_INT, "-1", "Resets two digit years to between this and 99 years later.  -1 = 50 years ago to 49 years time.", NULL, 0, "-1	5879510" },

{ CED_INIFILE_GRAPH_PANE_POS,	MTKIT_PREF_TYPE_INT, "-1" },
{ CED_INIFILE_FIND_PANE_POS,	MTKIT_PREF_TYPE_INT, "-1" },
{ CED_INIFILE_FIND_WILDCARDS,	MTKIT_PREF_TYPE_BOOL, "0" },
{ CED_INIFILE_FIND_CASE_SENSITIVE, MTKIT_PREF_TYPE_BOOL, "0" },
{ CED_INIFILE_FIND_VALUE,	MTKIT_PREF_TYPE_BOOL, "0" },
{ CED_INIFILE_FIND_ALL_SHEETS,	MTKIT_PREF_TYPE_BOOL, "0" },

{ CED_INIFILE_FIND_TEXT,	MTKIT_PREF_TYPE_STR, "" },

{ CED_INIFILE_PAGE_FONT_SIZE,	MTKIT_PREF_TYPE_INT, "12" },
{ CED_INIFILE_PAGE_WIDTH,	MTKIT_PREF_TYPE_INT, "297" },
{ CED_INIFILE_PAGE_HEIGHT,	MTKIT_PREF_TYPE_INT, "210" },
{ CED_INIFILE_PAGE_MARGIN_X,	MTKIT_PREF_TYPE_INT, "10" },
{ CED_INIFILE_PAGE_MARGIN_Y,	MTKIT_PREF_TYPE_INT, "10" },

{ CED_INIFILE_PAGE_HEADER_LEFT, MTKIT_PREF_TYPE_OPTION, "2", NULL, NULL, 0, CED_HEADER_OPTIONS },
{ CED_INIFILE_PAGE_HEADER_CENTRE, MTKIT_PREF_TYPE_OPTION, "0", NULL, NULL, 0, CED_HEADER_OPTIONS },
{ CED_INIFILE_PAGE_HEADER_RIGHT, MTKIT_PREF_TYPE_OPTION, "3", NULL, NULL, 0, CED_HEADER_OPTIONS },
{ CED_INIFILE_PAGE_FOOTER_LEFT, MTKIT_PREF_TYPE_OPTION, "6", NULL, NULL, 0, CED_HEADER_OPTIONS },
{ CED_INIFILE_PAGE_FOOTER_CENTRE, MTKIT_PREF_TYPE_OPTION, "0", NULL, NULL, 0, CED_HEADER_OPTIONS },
{ CED_INIFILE_PAGE_FOOTER_RIGHT, MTKIT_PREF_TYPE_OPTION, "4", NULL, NULL, 0, CED_HEADER_OPTIONS },

{ CED_INIFILE_GRAPH_SCALE,	MTKIT_PREF_TYPE_DOUBLE, "1", NULL, pref_change_graph_scale, 0, "0.1	1000", ptr },

{ CED_INIFILE_SHEET_PREFS_PERSIST, MTKIT_PREF_TYPE_BOOL, "0", "Keep sheet preferences (cursor area, frozen panes) when loading a new text file after a previous text file" },

	{NULL}
	};


	prefs_mem = mtkit_prefs_new ( prefs_table );

	if ( filename )
	{
		strncpy ( prefs_filename, filename, sizeof ( prefs_filename ) );
	}
	else
	{
		snprintf ( prefs_filename, sizeof ( prefs_filename ), "%s/.%s",
			mtkit_file_home (), BIN_NAME );
	}

	prefs_filename[sizeof ( prefs_filename ) - 1] = 0;
}

void prefs_load ()
{
	mtkit_prefs_load ( prefs_mem, prefs_filename );
}

void prefs_save ()
{
	mtkit_prefs_save ( prefs_mem, prefs_filename );
}

void prefs_close ()
{
	mtkit_prefs_destroy ( prefs_mem );
	prefs_mem = NULL;
}

mtPrefs * prefs_file ()
{
	return prefs_mem;
}

void prefs_set_int (
	const char	* key,
	int		value
	)
{
	mtkit_prefs_set_int ( prefs_mem, (char *)key, value );
}

void prefs_set_string (
	const char	* key,
	const char	* value
	)
{
	mtkit_prefs_set_str ( prefs_mem, (char *)key, (char *)value );
}

void prefs_set_double (
	const char	* key,
	double		value
	)
{
	mtkit_prefs_set_double ( prefs_mem, (char *)key, value );
}

int prefs_get_int (
	const char	* key
	)
{
	int		res = 0;


	mtkit_prefs_get_int ( prefs_mem, (char *)key, &res );

	return res;
}

char * prefs_get_string (
	const char	* key
	)
{
	static char	* nothing = "";
	char		* res = nothing;


	mtkit_prefs_get_str ( prefs_mem, (char *)key, &res );

	if ( ! res )
	{
		return nothing;
	}

	return res;
}

double prefs_get_double (
	const char	* key
	)
{
	double		res = 0;


	mtkit_prefs_get_double ( prefs_mem, (char *)key, &res );

	return res;
}

static void be_book_prefs_transfer (
	mtPrefs		* prefs,
	CedBook		* book,
	int		write_mode
	)
{
	mtBulkInt	table_i[] = {
			{ CED_FILE_PREFS_BOOK_DISABLE_LOCKS, &book->prefs.disable_locks },
			{ CED_FILE_PREFS_BOOK_AUTO_RECALC, &book->prefs.auto_recalc },
			{ NULL }
			};
	mtBulkStr	table_s[] = {
			{ CED_FILE_PREFS_BOOK_AUTHOR, &book->prefs.author },
			{ CED_FILE_PREFS_BOOK_COMMENT, &book->prefs.comment },
			{ NULL }
			};


	if ( write_mode )
	{
		// Write to book from prefs
		mtkit_prefs_bulk_get ( prefs, table_i, NULL, table_s );
	}
	else
	{
		// Read from book to prefs
		mtkit_prefs_bulk_set ( prefs, table_i, NULL, table_s );
	}
}

mtPrefs * be_book_prefs_init (
	CedBook		* book
	)
{
	mtPrefs		* prefs;
	mtPrefItem	item_table[] = {
	{ CED_FILE_PREFS_BOOK_AUTHOR, MTKIT_PREF_TYPE_STR_MULTI, "", _("Book Author") },
	{ CED_FILE_PREFS_BOOK_COMMENT, MTKIT_PREF_TYPE_STR_MULTI, "", _("Book Comment") },
	{ CED_FILE_PREFS_BOOK_DISABLE_LOCKS, MTKIT_PREF_TYPE_BOOL, "0", _("Disable all cell locks") },
	{ CED_FILE_PREFS_BOOK_AUTO_RECALC, MTKIT_PREF_TYPE_OPTION, "1", _("Automatically recalculate the sheet or book after changes"), NULL, 0, _("None	Sheet	Book") },
	{ NULL }
	};


	// Load window prefs
	prefs = fe_load_pref_window_prefs ( item_table );
	be_book_prefs_transfer ( prefs, book, 0 );

	return prefs;
}

void be_book_prefs_finish (
	mtPrefs		* prefs,
	CedBook		* book
	)
{
	be_book_prefs_transfer ( prefs, book, 1 );
}

int be_color_swatch_get (
	int		i
	)
{
static int swatch_color_table [ COLOR_SWATCH_TOTAL + 1 ] = {
	MTPIXEL_RGB_2_INT (   0,   0,   0 ),
	MTPIXEL_RGB_2_INT (  90,   0,   0 ),
	MTPIXEL_RGB_2_INT ( 100,  72,   0 ),
	MTPIXEL_RGB_2_INT ( 100, 100,   0 ),
	MTPIXEL_RGB_2_INT (   0,  90,   0 ),
	MTPIXEL_RGB_2_INT (   0,  90,  90 ),
	MTPIXEL_RGB_2_INT (   0,   0, 100 ),
	MTPIXEL_RGB_2_INT (  90,   0,  90 ),

	MTPIXEL_RGB_2_INT ( 100, 100, 100 ),
	MTPIXEL_RGB_2_INT ( 170,   0,   0 ),
	MTPIXEL_RGB_2_INT ( 180, 106,   0 ),
	MTPIXEL_RGB_2_INT ( 170, 170,   0 ),
	MTPIXEL_RGB_2_INT (   0, 160,   0 ),
	MTPIXEL_RGB_2_INT (   0, 160, 160 ),
	MTPIXEL_RGB_2_INT (   0, 100, 180 ),
	MTPIXEL_RGB_2_INT ( 150,   0, 150 ),

	MTPIXEL_RGB_2_INT ( 180, 180, 180 ),
	MTPIXEL_RGB_2_INT ( 230, 140, 140 ),
	MTPIXEL_RGB_2_INT ( 230, 150,   0 ),
	MTPIXEL_RGB_2_INT ( 220, 220, 100 ),
	MTPIXEL_RGB_2_INT ( 120, 220, 120 ),
	MTPIXEL_RGB_2_INT ( 100, 230, 230 ),
	MTPIXEL_RGB_2_INT ( 100, 200, 255 ),
	MTPIXEL_RGB_2_INT ( 230, 140, 230 ),

	MTPIXEL_RGB_2_INT ( 220, 220, 220 ),
	MTPIXEL_RGB_2_INT ( 255, 200, 200 ),
	MTPIXEL_RGB_2_INT ( 255, 216, 160 ),
	MTPIXEL_RGB_2_INT ( 255, 255, 160 ),
	MTPIXEL_RGB_2_INT ( 180, 255, 180 ),
	MTPIXEL_RGB_2_INT ( 180, 255, 255 ),
	MTPIXEL_RGB_2_INT ( 180, 230, 255 ),
	MTPIXEL_RGB_2_INT ( 255, 200, 255 ),

	MTPIXEL_RGB_2_INT ( 255, 255, 255 ),
	MTPIXEL_RGB_2_INT ( 255,   0,   0 ),
	MTPIXEL_RGB_2_INT ( 255, 200,   0 ),
	MTPIXEL_RGB_2_INT ( 255, 255,   0 ),
	MTPIXEL_RGB_2_INT (   0, 255,   0 ),
	MTPIXEL_RGB_2_INT (   0, 255, 255 ),
	MTPIXEL_RGB_2_INT (   0,   0, 255 ),
	MTPIXEL_RGB_2_INT ( 255,   0, 255 )
	};


	if ( i >= COLOR_SWATCH_TOTAL || i < 0 )
	{
		return 0;
	}

	return swatch_color_table [ i ];
}

