/*
	Copyright (C) 2013-2014 Mark Tyler

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program in the file COPYING.
*/

#ifdef U_TK_QT4
	#include <mtqex4.h>
#endif

#ifdef U_TK_QT5
	#include <mtqex5.h>
#endif



#ifdef __cplusplus
	extern "C" {
#endif	//  __cplusplus


// C API

#include "be.h"



#ifdef __cplusplus
	}
#endif	//  __cplusplus



QT_BEGIN_NAMESPACE

class	QComboBox;
class	QMainWindow;
class	QProgressBar;
class	QPushButton;
class	QTabWidget;
class	QTableWidget;

QT_END_NAMESPACE



#define TABLE_MAX		10
#define PROGRESS_MAX		100
#define PROGRESS_NEXT		-1



class	MainWindow;
class	mtTableAnalysis;



class MainWindow : public QMainWindow
{
	Q_OBJECT

public:
	MainWindow	();
	~MainWindow	();

	int		doAnalysis ( const char * path );
	void		setProgress ( int val );
			// 0..100 set value, -1 = Increment
	int		isBusy ();		// 0 = idle
	void		stopNow ();
	int		wasStopped ();		// 0 = not stopped

protected:
	void		closeEvent ( QCloseEvent * event );

private slots:
	void		pressButtonQuit ();
	void		pressButtonCopy ();
	void		pressTabNext ();
	void		pressTabPrevious ();

private:
	int		progressBarValue,	// 0 = Idle, 1..100 = Busy
			stopFlag
			;
	mtTableAnalysis	* table [ TABLE_MAX ];

	QProgressBar	* progressBar;
	QTabWidget	* tabWidget;
	QPushButton	* buttonCopy;
};

class mtTableAnalysis : public QTableWidget
{
	Q_OBJECT

public:
	mtTableAnalysis (
			CedSheet	* sheetData,
			const char	* pathToAnalyse,
			MainWindow	* mainwin,
			QVBoxLayout	* layout
			);
	~mtTableAnalysis ();

	void		copyToClipboard ();

private slots:
	void		tableCellActivated ( int row, int column );
	void		tableHeaderClick ( int index );

private:
	int		sortColumn,
			sheetRowTotal;
	Qt::SortOrder	sortDirection;
	char		* path;
	CedSheet	* sheet;
	MainWindow	* mainWindow;

	void		sortTable ( int column, Qt::SortOrder direction );
				// -column = Flip or descending
};

