#!/bin/sh
# Build and install script for all packages.
# Mark Tyler 2011-12-7


MT_flush_func()
{
	if [ "$PKG_LIST" = "" ]
	then
		PKG_LIST=$APPS_DIR_ALL
	fi

	for PKG in $PKG_LIST
	do
		UNDERLINE_TEXT "Flushing $PKG"

		MT_GET_PKG_DIR "$PKG"
		cd $CWD/../$PKG_DIR-*
		./configure flush
	done
}


MT_run_com()
{
	TMPFILE=_TMP.sh

	echo $* > $TMPFILE
	chmod a+x $TMPFILE
	cat $TMPFILE

	./$TMPFILE
	RES=$?
	rm $TMPFILE

	if [ "$RES" != "0" ]
	then
		echo Error!
		exit 1
	fi
}


MT_build_app_func()
{
	echo
	echo $PKG

	MT_GET_PKG_DIR "$PKG"
	cd $CWD/../$PKG_DIR-*

	MT_run_com $CONF


	# On error exit
	set -e

	make clean
	make
	sudo make install

	# Don't exit on error
	set +e
}


MT_remove_func()
{
	# On error exit
	set -e


	REV_APPS=$( echo $PKG_LIST | tac -s " " )

	echo
	echo $REV_APPS
	echo

	for PKG in $REV_APPS
	do
		UNDERLINE_TEXT "Removing $PKG"

		CONF=$(cat "$CWD/$BCFILE" |
			awk -F "\t" -v PKG="$PKG" '$1==PKG { print $2; exit }')

		MT_GET_PKG_DIR "$PKG"
		cd $CWD/../$PKG_DIR-*

		# Don't exit on error
		set +e

		./configure flush

		# On error exit
		set -e

		$CONF
		sudo make uninstall
	done


	# Don't exit on error
	set +e
}


. ./_build_global.txt


MT_STARTUP

MT_PARSE_ARGS "$@"

MT_CREATE_BCFILE

MT_DISPLAY_INFO "Generic - ./configure, make, make install"

MT_ACTION_BUILD

